Loading...
Searching...
No Matches
gr::channels::channel_model2 Class Referenceabstract
GNU Radio C++ Signal Processing Blocks » Channel Models

Basic channel simulator allowing time-varying frequency and timing inputs. More...

`#include <gnuradio/channels/channel_model2.h>`

## Public Types

typedef std::shared_ptr< channel_model2 > | sptr
Public Types inherited from gr::hier_block2
typedef basic_block_sptr | opaque_self
| typedef for object returned from self().

## Public Member Functions

virtual void | set_noise_voltage (double noise_voltage)=0
virtual void | set_taps (const std::vector< gr_complex > &taps)=0
virtual void | set_timing_offset (double epsilon)=0
virtual double | noise_voltage () const =0
virtual std::vector< gr_complex > | taps () const =0
virtual double | timing_offset () const =0
Public Member Functions inherited from gr::hier_block2
| ~hier_block2 () override
opaque_self | self ()
| Return an object, representing the current block, which can be passed to connect.
void | connect (basic_block_sptr block)
| Add a stand-alone (possibly hierarchical) block to internal graph.
void | connect (basic_block_sptr src, int src_port, basic_block_sptr dst, int dst_port)
| Add gr-blocks or hierarchical blocks to internal graph and wire together.
void | msg_connect (basic_block_sptr src, pmt::pmt_t srcport, basic_block_sptr dst, pmt::pmt_t dstport)
| Add gr-blocks or hierarchical blocks to internal graph and wire together.
void | msg_connect (basic_block_sptr src, std::string srcport, basic_block_sptr dst, std::string dstport)
void | msg_disconnect (basic_block_sptr src, pmt::pmt_t srcport, basic_block_sptr dst, pmt::pmt_t dstport)
void | msg_disconnect (basic_block_sptr src, std::string srcport, basic_block_sptr dst, std::string dstport)
void | disconnect (basic_block_sptr block)
| Remove a gr-block or hierarchical block from the internal flowgraph.
void | disconnect (basic_block_sptr src, int src_port, basic_block_sptr dst, int dst_port)
| Disconnect a pair of gr-blocks or hierarchical blocks in internal flowgraph.
void | disconnect_all ()
| Disconnect all connections in the internal flowgraph.
virtual void | lock ()
virtual void | unlock ()
int | max_output_buffer (size_t port=0)
| Returns max buffer size (itemcount) on output port `i`.
void | set_max_output_buffer (int max_output_buffer)
| Sets max buffer size (itemcount) on all output ports.
void | set_max_output_buffer (size_t port, int max_output_buffer)
| Sets max buffer size (itemcount) on output port `port`.
int | min_output_buffer (size_t port=0)
| Returns min buffer size (itemcount) on output port `i`.
void | set_min_output_buffer (int min_output_buffer)
| Sets min buffer size (itemcount) on all output ports.
void | set_min_output_buffer (size_t port, int min_output_buffer)
| Sets min buffer size (itemcount) on output port `port`.
flat_flowgraph_sptr | flatten () const
hier_block2_sptr | to_hier_block2 ()
bool | has_msg_port (pmt::pmt_t which_port) override
bool | message_port_is_hier (pmt::pmt_t port_id) override
bool | message_port_is_hier_in (pmt::pmt_t port_id) override
bool | message_port_is_hier_out (pmt::pmt_t port_id) override
void | message_port_register_hier_in (pmt::pmt_t port_id)
void | message_port_register_hier_out (pmt::pmt_t port_id)
void | set_processor_affinity (const std::vector< int > &mask) override
| Set the affinity of all blocks in hier_block2 to processor core `n`.
void | unset_processor_affinity () override
| Remove processor affinity for all blocks in hier_block2.
std::vector< int > | processor_affinity () override
| Get the current processor affinity.
void | set_log_level (const std::string &level) override
| Set the logger's output level.
std::string | log_level () override
| Get the logger's output level.
bool | all_min_output_buffer_p (void)
| Get if all block min buffers should be set.
bool | all_max_output_buffer_p (void)
| Get if all block max buffers should be set.
Public Member Functions inherited from gr::basic_block
pmt::pmt_t | message_subscribers (pmt::pmt_t port)
| ~basic_block () override
long | unique_id () const
long | symbolic_id () const
std::string | name () const
std::string | symbol_name () const
std::string | identifier () const
gr::io_signature::sptr | input_signature () const
gr::io_signature::sptr | output_signature () const
basic_block_sptr | to_basic_block ()
bool | alias_set () const
std::string | alias () const
pmt::pmt_t | alias_pmt () const
void | set_block_alias (std::string name)
void | message_port_register_in (pmt::pmt_t port_id)
void | message_port_register_out (pmt::pmt_t port_id)
void | message_port_pub (pmt::pmt_t port_id, pmt::pmt_t msg)
void | message_port_sub (pmt::pmt_t port_id, pmt::pmt_t target)
void | message_port_unsub (pmt::pmt_t port_id, pmt::pmt_t target)
pmt::pmt_t | message_ports_in ()
| Get input message port names.
pmt::pmt_t | message_ports_out ()
| Get output message port names.
void | _post (pmt::pmt_t which_port, pmt::pmt_t msg)
bool | empty_p (pmt::pmt_t which_port)
| is the queue empty?
bool | empty_p ()
bool | empty_handled_p (pmt::pmt_t which_port)
| are all msg ports with handlers empty?
bool | empty_handled_p ()
size_t | nmsgs (pmt::pmt_t which_port)
| How many messages in the queue?
void | insert_tail (pmt::pmt_t which_port, pmt::pmt_t msg)
pmt::pmt_t | delete_head_nowait (pmt::pmt_t which_port)
msg_queue_t::iterator | get_iterator (pmt::pmt_t which_port)
void | erase_msg (pmt::pmt_t which_port, msg_queue_t::iterator it)
const msg_queue_map_t & | get_msg_map (void) const
virtual void | setup_rpc ()
| Set up the RPC registered variables.
bool | is_rpc_set ()
| Ask if this block has been registered to the RPC.
void | rpc_set ()
| When the block is registered with the RPC, set this.
virtual bool | check_topology (int ninputs, int noutputs)
| Confirm that ninputs and noutputs is an acceptable combination.
template<typename T>
void | set_msg_handler (pmt::pmt_t which_port, T msg_handler)
| Set the callback that is fired when messages are available.
Public Member Functions inherited from gr::msg_accepter
| msg_accepter ()
| ~msg_accepter () override
void | post (pmt::pmt_t which_port, pmt::pmt_t msg) override
| send `msg` to `msg_accepter` on port `which_port`
Public Member Functions inherited from gr::messages::msg_accepter
| msg_accepter ()

## Static Public Member Functions

static sptr | make (double noise_voltage=0.0, double epsilon=1.0, const std::vector< gr_complex > &taps=std::vector< gr_complex >(1, 0), double noise_seed=0, bool block_tags=false)
| Build the channel simulator.

## Additional Inherited Members

Public Attributes inherited from gr::hier_block2
pmt::pmt_t | hier_message_ports_in
pmt::pmt_t | hier_message_ports_out
Protected Types inherited from gr::basic_block
enum | vcolor { WHITE , GREY , BLACK }
Protected Member Functions inherited from gr::hier_block2
| hier_block2 ()
| hier_block2 (const std::string &name, gr::io_signature::sptr input_signature, gr::io_signature::sptr output_signature)
Protected Member Functions inherited from gr::basic_block
| basic_block (void)
| basic_block (const std::string &name, gr::io_signature::sptr input_signature, gr::io_signature::sptr output_signature)
| Protected constructor prevents instantiation by non-derived classes.
void | set_input_signature (gr::io_signature::sptr iosig)
| may only be called during constructor
void | set_output_signature (gr::io_signature::sptr iosig)
| may only be called during constructor
void | set_color (vcolor color)
| Allow the flowgraph to set for sorting and partitioning.
vcolor | color () const
virtual bool | has_msg_handler (pmt::pmt_t which_port)
| Tests if there is a handler attached to port `which_port`.
virtual void | dispatch_msg (pmt::pmt_t which_port, pmt::pmt_t msg)
template<typename Derived>
std::shared_ptr< Derived > | shared_from_base ()
| This is meant to be called by derived classes (e.g. block) to get a shared pointer internally. This is needed because std::enable_shared_from_this doesn't seem to work with derived classes in an inheritance hierarchy.
Protected Attributes inherited from gr::basic_block
std::string | d_name
gr::io_signature::sptr | d_input_signature
gr::io_signature::sptr | d_output_signature
long | d_unique_id
long | d_symbolic_id
std::string | d_symbol_name
std::string | d_symbol_alias
vcolor | d_color
bool | d_rpc_set
gr::logger_ptr | d_logger
gr::logger_ptr | d_debug_logger
| Default logger.
msg_queue_map_t | msg_queue
| Verbose logger.
std::vector< rpcbasic_sptr > | d_rpc_vars
pmt::pmt_t | d_message_subscribers

## Detailed Description

Basic channel simulator allowing time-varying frequency and timing inputs.

This block implements a basic channel model simulator that can be used to help evaluate, design, and test various signals, waveforms, and algorithms.

This model allows the user to set the voltage of an AWGN noise source (`noise_voltage`), an initial timing offset (`epsilon`), and a seed (`noise_seed`) to randomize the AWGN noise source.

Multipath can be approximated in this model by using a FIR filter representation of a multipath delay profile with the parameter `taps`.

Unlike gr::channels::channel_model, this block is designed to enable time-varying frequency and timing offsets.

- Port 0: input signal to be run through the channel.
- Port 1: frequency function. A constant value between -0.5 and 0.5 here will turn into a constant frequency offset from -fs/2 to fs/2 (where fs is the sample rate).
- Port 2: timing offset function. Sets the resampling rate of the channel model. A constant value here produces that value as the timing offset, so a constant 1.0 input stream is the same as not having a timing offset.

Since the models for frequency and timing offset may vary and what we are trying to model may be different for different simulations, we provide the time-varying nature as an input function that is user-defined. If only constant frequency and timing offsets are required, it is easier and less expensive to use gr::channels::channel_model.

## Member Typedef Documentation

## sptr

typedef std::shared_ptr<channel_model2> gr::channels::channel_model2::sptr

## Member Function Documentation

## make()

sptr gr::channels::channel_model2::make | ( | double | noise_voltage = 0.0,
|  | double | epsilon = 1.0,
|  | const std::vector< gr_complex > & | taps = std::vector< gr_complex >(1, 0),
|  | double | noise_seed = 0,
|  | bool | block_tags = false )

static

Build the channel simulator.

Parameters

  noise_voltage | The AWGN noise level as a voltage (to be calculated externally to meet, say, a desired SNR).
  epsilon | The initial sample timing offset to emulate the different rates between the sample clocks of the transmitter and receiver. 1.0 is no difference.
  taps | Taps of a FIR filter to emulate a multipath delay profile.
  noise_seed | A random number generator seed for the noise source.
  block_tags | If true, tags will not be able to propagate through this block.

References noise_voltage(), and taps().

## noise_voltage()

virtual double gr::channels::channel_model2::noise_voltage | ( |  | ) | const

pure virtual

Referenced by make(), and set_noise_voltage().

## set_noise_voltage()

virtual void gr::channels::channel_model2::set_noise_voltage | ( | double | noise_voltage | ) |

pure virtual

References noise_voltage().

## set_taps()

virtual void gr::channels::channel_model2::set_taps | ( | const std::vector< gr_complex > & | taps | ) |

pure virtual

References taps().

## set_timing_offset()

virtual void gr::channels::channel_model2::set_timing_offset | ( | double | epsilon | ) |

pure virtual

## taps()

virtual std::vector< gr_complex > gr::channels::channel_model2::taps | ( |  | ) | const

pure virtual

Referenced by make(), and set_taps().

## timing_offset()

virtual double gr::channels::channel_model2::timing_offset | ( |  | ) | const

pure virtual

The documentation for this class was generated from the following file:

- channel_model2.h